run_my_solution = False
assignmentNumber = '4'

import os
import copy
import signal
import os
import numpy as np
import subprocess

if run_my_solution:
    from A4mysolution import *
    print('##############################################')
    print("RUNNING INSTRUCTOR's SOLUTION!!!!!!!!!!!!")
    print('##############################################')

else:
    
    print('\n======================= Code Execution =======================\n')


    if False:  # Because only grading code in neuralnetworkA3.py.  Using jupyter nbconvert to run notebook

        import subprocess, glob, pathlib

        nb_name = f'*A{assignmentNumber}solution*.ipynb'
        # nb_name = '*.ipynb'
        filename = next(glob.iglob(nb_name), None)
        print(nb_name, filename)

        print('Extracting python code from notebook named \'{}\' and storing in notebookcode.py'.format(filename))
        if not filename:
            raise Exception(f'Please rename your notebook file to A{assignmentNumber}solution.ipynb'.format(assignmentNumber))
        with open('notebookcode.py', 'w') as outputFile:
            comm = f'jupyter nbconvert --to script {nb_name} --stdout'
            # subprocess.call(shlex.split(comm), stdout=outputFile, shell=True)
            subprocess.call(comm.split(), stdout=outputFile, shell=True)
        # from https://stackoverflow.com/questions/30133278/import-only-functions-from-a-python-file
        import sys
        import ast
        import types
        with open('notebookcode.py') as fp:
            tree = ast.parse(fp.read(), 'eval')
        print('Removing all statements that are not function or class defs or import statements.')
        for node in tree.body[:]:
            if (not isinstance(node, ast.FunctionDef) and
                not isinstance(node, ast.Import) and
                not isinstance(node, ast.ImportFrom) and
                not isinstance(node, ast.ClassDef)):
                tree.body.remove(node)
        # Now write remaining code to py file and import it
        module = types.ModuleType('notebookcodeStripped')
        code = compile(tree, 'notebookcodeStripped.py', 'exec')
        sys.modules['notebookcodeStripped'] = module
        exec(code, module.__dict__)
        # import notebookcodeStripped as useThisCode
        from notebookcodeStripped import *

print('\n============================\n import neuralnetworksA4 as nn \n============================')
import neuralnetworksA4 as nn
    
try:
    
    if nn.NeuralNetwork and nn.NeuralNetworkClassifier:
        print('neuralnetworksA4.py defines NeuralNetwork and NeuralNetworkClassifier')

except:
    raise Exception('NeuralNetwork and NeuralNetworkClassifier classes are not defined in neuralnetworksA4.py')

# required_funcs = ['nn.NeuralNetwork', 'nn.NeuralNetworkClassifier']

# for func in required_funcs:
#     if func not in dir() or not callable(globals()[func]):
#         print('CRITICAL ERROR: Function named \'{}\' is not defined'.format(func))
#         print('  Check the spelling and capitalization of the function name.')

exec_grade = 0


#### constructor ##################################################################

print('''
## Testing inheritance ####################################################################

    correct = issubclass(nn.NeuralNetworkClassifier, nn.NeuralNetwork)
''')
      
try:
    pts = 10
    correct = issubclass(nn.NeuralNetworkClassifier, nn.NeuralNetwork)

    if correct:
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. NeuralNetworkClassifier correctly extends NeuralNetwork.')
    else:
        print(f'\n---  0/{pts} points. NeuralNetworkClassifier should extend NeuralNetwork but it does not.')
except Exception as ex:
    print(f'\n--- 0/{pts} points. NeuralNetworkClassifier raised the exception:\n')
    print(ex)




print('''
## Testing inheritance ####################################################################

    # Checking if the _forward function in NeuralNetworkClassifier is inherited from NeuralNetwork

    import inspect
    forward_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == 'forward' or f.name == '_forward')]
    correct = forward_func[0].defining_class == nn.NeuralNetwork
''')
      
try:
    pts = 5

    import inspect
    forward_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == 'forward' or f.name == '_forward')]
    correct = forward_func[0].defining_class == nn.NeuralNetwork

    if correct:
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. NeuralNetworkClassifier _forward function correctly inherited from NeuralNetwork.')
    else:
        print(f'\n---  0/{pts} points. NeuralNetworkClassifier _forward function should be inherited from NeuralNetwork.')
except Exception as ex:
    print(f'\n--- 0/{pts} points. Test raised the exception:\n')
    print(ex)


print('''
## Testing inheritance ####################################################################

    # Checking if __str__ in NeuralNetworkClassifier is inherited from NeuralNetwork
    import inspect
    str_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == '__str__')]
    correct = str_func[0].defining_class == nn.NeuralNetwork
''')
      
try:
    pts = 5

    import inspect
    str_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == '__str__')]
    correct = str_func[0].defining_class == nn.NeuralNetwork

    if correct:
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. NeuralNetworkClassifier __str__ function correctly inherited from NeuralNetwork.')
    else:
        print(f'\n---  0/{pts} points. NeuralNetworkClassifier __str__ function should be inherited from NeuralNetwork.')
except Exception as ex:
    print(f'\n--- 0/{pts} points. Test raised the exception:\n')
    print(ex)


print('''
## Testing inheritance ####################################################################

    # Checking if _gradient_f in NeuralNetworkClassifier is defined (overridden) in NeuralNetworkClassifier
    import inspect
    str_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == '_gradient_f')]
    correct = str_func[0].defining_class == nn.NeuralNetworkClassifier
''')
      
try:
    pts = 5

    import inspect
    str_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == '_gradient_f')]
    correct = str_func[0].defining_class == nn.NeuralNetworkClassifier

    if correct:
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. NeuralNetworkClassifier _gradient_f function correctly defined in NeuralNetworkClassifier.')
    else:
        print(f'\n---  0/{pts} points. NeuralNetworkClassifier _gradient_f function should be defined in NeuralNetworkClassifier.')
except Exception as ex:
    print(f'\n--- 0/{pts} points. Test raised the exception:\n')
    print(ex)


print('''
## Testing inheritance ####################################################################

    # Checking if _backpropagate in NeuralNetworkClassifier is inherited from NeuralNetwork
    import inspect
    str_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == '_backpropagate')]
    correct = str_func[0].defining_class == nn.NeuralNetwork
''')
      
try:
    pts = 5

    import inspect
    str_func = [f for f in inspect.classify_class_attrs(nn.NeuralNetworkClassifier) if (f.name == '_backpropagate')]
    correct = str_func[0].defining_class == nn.NeuralNetwork

    if correct:
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. NeuralNetworkClassifier _backpropagate function correctly inherited from NeuralNetwork.')
    else:
        print(f'\n---  0/{pts} points. NeuralNetworkClassifier _backpropagate function should be inherited from  NeuralNetwork.')
except Exception as ex:
    print(f'\n--- 0/{pts} points. Test raised the exception:\n')
    print(ex)



print('''
## Testing constructor ####################################################################

    nnet = nn.NeuralNetworkClassifier(2, [], 5)
    W_shapes = [W.shape for W in nnet.Ws]
''')
      
try:
    pts = 10
    nnet = nn.NeuralNetworkClassifier(2, [], 5)
    W_shapes = [W.shape for W in nnet.Ws]
    correct = [(3, 5)]

    if correct == W_shapes:
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. W_shapes is correct value of {W_shapes}')
    else:
        print(f'\n---  0/{pts} points. Returned incorrect values {W_shapes}.')
        print(f'                 Correct values are {correct}')
except Exception as ex:
    print(f'\n--- 0/{pts} points. NeuralNetworkClassifier raised the exception\n')
    print(ex)
    

print('''
## Testing constructor ####################################################################

    nnet = nn.NeuralNetworkClassifier(2, [], 5)
    G_shapes = [G.shape for G in nnet.Grads]
''')
      
try:
    pts = 10

    nnet = nn.NeuralNetworkClassifier(2, [], 5)
    G_shapes = [G.shape for G in nnet.Grads]
    correct = [(3, 5)]

    if correct == G_shapes:
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. G_shapes is correct value of {G_shapes}')
    else:
        print(f'\n---  0/{pts} points. Returned incorrect values {G_shapes}.')
        print(f'                 Correct values are {correct}')
except Exception as ex:
    print(f'\n--- 0/{pts} points. Accessing nnet.Gs raised the exception\n')
    print(ex)



# def print_layers(what, lst):
#     print(f'{what}:')
#     for (i, element) in enumerate(lst):
#         print(f' Layer {i}:')
#         print(f' {element}')



#### train  ##################################################################
print('''
## Testing train ####################################################################

    np.random.seed(42)
    X = np.random.uniform(0, 1, size=(100, 2))
    T = (np.abs(X[:, 0:1] - 0.5) > 0.3).astype(int)
    nnet = nn.NeuralNetworkClassifier(2, [10, 5], len(np.unique(T)))
    nnet.train(X, T, X, T, 20, method='scg')

    Then check  nnet.get_performance_trace()
''')

try:
    pts = 10
    np.random.seed(42)
    X = np.random.uniform(0, 1, size=(100, 2))
    T = (np.abs(X[:, 0:1] - 0.5) > 0.3).astype(int)
    nnet = nn.NeuralNetworkClassifier(2, [10, 5], len(np.unique(T)))
    nnet.train(X, T, X, T, 20, method='scg')

    last_error = nnet.get_performance_trace()[-1]
    correct = 0.9297448356260026

    if np.allclose(last_error, correct, atol=0.1):
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. Correct values in performance_trace')
    else:
        print(f'\n---  0/{pts} points. Incorrect values in performance_trace')
        print(f'                 Your value is {last_error[0]}, but it should be {correct}')

except Exception as ex:
    print(f'\n--- 0/{pts} points. nnet.train or get_performance_trace() raised the exception\n')
    print(ex)
    


#### train  ##################################################################
print('''
## Testing train ####################################################################

    np.random.seed(43)
    X = np.random.uniform(0, 1, size=(100, 2))
    T = (np.abs(X[:, 0:1] - X[:, 1:2]) < 0.5).astype(int)
    T[T == 0] = 10
    T[T == 1] = 20
    # Unique class labels are now 10 and 20!

    nnet = nn.NeuralNetworkClassifier(2, [10, 5], 2)
    nnet.train(X, T, 200, method='scg')
    classes, prob = nnet.use(X)
''')

try:
    pts = 10
    np.random.seed(43)
    X = np.random.uniform(0, 1, size=(20, 2))
    T = (np.abs(X[:, 0:1] - X[:, 1:2]) < 0.5).astype(int)
    T[T == 0] = 10
    T[T == 1] = 20
    # Unique class labels are now 10 and 20!

    nnet = nn.NeuralNetworkClassifier(2, [10, 5], 2)
    nnet.train(X, T, X, T, 200, method='scg')
    classes, prob = nnet.use(X)
    correct_classes = \
        np.array([[20],
                  [20],
                  [10],
                  [20],
                  [10],
                  [20],
                  [20],
                  [10],
                  [20],
                  [10],
                  [20],
                  [10],
                  [20],
                  [10],
                  [20],
                  [10],
                  [20],
                  [20],
                  [20],
                  [20]])
    correct_prob = \
        np.array([[7.87686254e-10, 9.99999999e-01],
                  [2.64073742e-10, 1.00000000e+00],
                  [1.00000000e+00, 2.17739214e-11],
                  [2.37507101e-10, 1.00000000e+00],
                  [1.00000000e+00, 5.72602779e-13],
                  [2.63951189e-10, 1.00000000e+00],
                  [3.07141256e-10, 1.00000000e+00],
                  [9.99999995e-01, 5.31601303e-09],
                  [5.18960837e-10, 9.99999999e-01],
                  [1.00000000e+00, 5.29910868e-15],
                  [2.31535786e-10, 1.00000000e+00],
                  [1.00000000e+00, 4.76259538e-17],
                  [2.31088925e-10, 1.00000000e+00],
                  [1.00000000e+00, 3.30767340e-16],
                  [3.09810289e-10, 1.00000000e+00],
                  [9.99999999e-01, 7.34252931e-10],
                  [2.31089312e-10, 1.00000000e+00],
                  [2.32724737e-10, 1.00000000e+00],
                  [2.69944404e-10, 1.00000000e+00],
                  [2.59802216e-10, 1.00000000e+00]])

    if np.allclose(classes, correct_classes, atol=0.1):
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. Correct values in classes')
    else:
        print(f'\n---  0/{pts} points. Incorrect values in classes')
        print(f'                 Your value is\n {classes}.')
        print(f'                 Correct value is\n {correct_classes}')

    if np.allclose(prob, correct_prob, atol=0.1):
        exec_grade += pts
        print(f'\n--- {pts}/{pts} points. Correct values in prob')
    else:
        print(f'\n---  0/{pts} points. Incorrect values in prob')
        print(f'                 Your value is\n {prob}.')
        print(f'                 Correct value is\n {correct_prob}')


except Exception as ex:
    print(f'\n--- 0/{pts} points. nnet.train or use raised the exception\n')
    print(ex)
    
    


    


name = os.getcwd().split('/')[-1]

print()
print('='*70)
print(f'{name} Execution Grade is {exec_grade} / 80')
print('='*70)

print('''

-- / 5 points. Experiment with the three different optimization methods,
               at least three hidden layer structures including [], two
               learning rates, and two numbers of epochs. Use verbose=False
               as an argument to train(). For scg, ignore the learning rate
               loop. Print a single line for each run showing method, number
               of epochs, learning rate, hidden layer structure, and percent
               correct for training, validation, and testing data.

__ / 5 points. Function make_mnist_classifier defined and used correctly.

__ / 5 points. Discuss your results. In your discussion, include observations about
                which method achieves the best result,
                which method seems to do best with fewer epochs,
                what common classification mistakes are made as shown in your confusion matrices, and
                do larger networks (more layers, more units) work better than small networks?

__ / 5 points. Train a network with values for method, learning rate, number of epochs,
               and a hidden layer structure with no more than 100 units in the first layer
               that you found work well. Extract the weight matrix from the first layer. Now,
               for each unit (column in the weight matrix) ignore the first row of bias weights
               and reshape the remaining weights into a 28 x 28 image for each unit and display
               them. Complete the function to draw the weight matrix for one unit using draw_digit
               as a guide, then use it in a loop to draw the weight matrices for each unit in
               the first layer of your network.
               Discuss what you see. Describe some of the images as patterns that could be
               useful for classifying particular digits.''')

print()
print('='*70)
print(f'{name} Results and Discussion Grade is ___ / 20')
print('='*70)


print()
print('='*70)
print(f'{name} FINAL GRADE is  _  / 100')
print('='*70)


print('''
Extra Credit: 
Repeat the above experiments with a different data set. Write in markdown cells descriptions
of the data and your results.''')

print(f'\n{name} EXTRA CREDIT is 0 / 1')


if run_my_solution:
    print('##############################################')
    print("RUNNING INSTRUCTOR's SOLUTION!!!!!!!!!!!!")
    print('##############################################')


